/* ----  Copyright (C) 1997 Alex Solomonoff ( asolomon@bbn.com )
This file is part of Invariant, a library of C++ tools for debugging and 
program consistancy checking. Invariant is free software; you can redistribute
it and/or modify it under the terms of the GNU Library General Public License,
version 2, as published by the Free Software Foundation.  ----- */

//	Intended to be included into the class declaration of a smart number
//	class, to implement common functions.
//	Can be included several times in the same file.

#ifdef __USES_PREV
#	define SAVE_OLD			number old_value = value
#	define CHECK			check_prev(old_value)
#else
#	define SAVE_OLD			(void)0
#	define CHECK			check()
#endif

	const __ARITH_TYPE operator++(int)  // x++
	{	 number old_value = value;
		++value;	
		CHECK;
		return __ARITH_TYPE(old_value);		
	}
		
	const __ARITH_TYPE operator--(int)  // x--
	{	 number old_value = value;
		--value;
		CHECK;
		return __ARITH_TYPE(old_value);
	}

	__ARITH_TYPE & operator--()  // --x
	{
		SAVE_OLD;
		--value;
		CHECK;
		return  *this;
	}

	__ARITH_TYPE operator-()    // -x
	{	return __ARITH_TYPE(-value);
	}

	__ARITH_TYPE & operator++()  // --x
	{	
		SAVE_OLD;
		++value;
		CHECK;
		return  *this;
	}

	__ARITH_TYPE & operator+=(const number & n)
	{
		SAVE_OLD;
		value += n;
		CHECK;
		return  *this;
	}
		
	__ARITH_TYPE & operator-=(const number & n)
	{	
		SAVE_OLD;
		value -= n;
		CHECK;
		return  *this;
	}

	__ARITH_TYPE & operator*=(const number & n)
	{
		SAVE_OLD;
		value *= n;
		CHECK;
		return  *this;
	}

	__ARITH_TYPE & operator/=(const number & n)
	{
		SAVE_OLD;
		value /= n;
		CHECK;
		return  *this;
	}

#undef SAVE_OLD
#undef CHECK
