/* ----  Copyright (C) 1997 Alex Solomonoff ( asolomon@bbn.com )
This file is part of Invariant, a library of C++ tools for debugging and 
program consistancy checking. Invariant is free software; you can redistribute
it and/or modify it under the terms of the GNU Library General Public License,
version 2, as published by the Free Software Foundation.  ----- */

#if defined(__SOLARIS___) || defined(__SGI_IRIX__)
#       include <ieeefp.h>
#elif __SGI_IRIX_SIGFPE___
#       include <sigfpe.h>
#elif __LINUX_I386__
#       define _FPU_EXCEPT 0x1372
#	ifdef  __cplusplus
		extern "C" {	int invl_getfpucw();
				void invl_setfpucw(unsigned short); }
#	else
		int invl_getfpucw();
		void invl_setfpucw(unsigned short);
#	endif
#endif

static int _orig_fpucw;
static int _orig_fpucw_set = 0;

void
set_fp_exceptions()
{
#	if defined(__SOLARIS___) || defined(__SGI_IRIX__)
		int oldmask;
                oldmask = fpsetmask(FP_X_INV | FP_X_OFL | FP_X_DZ );
		if ( !_orig_fpucw_set)
			_orig_fpucw = oldmask;
#	elif __SGI_IRIX_SIGFPE__
		if ( !_orig_fpucw_set)
			_orig_fpucw = 0;
                sigfpe_[_OVERFL ].abort=1;
                sigfpe_[_DIVZERO].abort=1;
                sigfpe_[_INVALID].abort=1;
                handle_sigfpes(_ON,  _EN_OVERFL | _EN_DIVZERO | _EN_INVALID,
                        0, _ABORT_ON_ERROR, 0);
#       elif __LINUX_I386__
		if ( !_orig_fpucw_set)
			_orig_fpucw = invl_getfpucw();
                invl_setfpucw(_FPU_EXCEPT);
#       endif

	_orig_fpucw_set = 1;
}

void
unset_fp_exceptions()
{
	if ( !_orig_fpucw_set)
		return;

#	if defined(__SOLARIS___) || defined(__SGI_IRIX__)
		fpsetmask(_orig_fpucw);
#	elif __SGI_IRIX_SIGFPE__
                handle_sigfpes(_OFF, 0, 0, _ABORT_ON_ERROR, 0);
#       elif __LINUX_I386__
		invl_setfpucw(_orig_fpucw);
#	endif
}

