/* ----  Copyright (C) 1997 Alex Solomonoff ( asolomon@bbn.com )
This file is part of Invariant, a library of C++ tools for debugging and 
program consistancy checking. Invariant is free software; you can redistribute
it and/or modify it under the terms of the GNU Library General Public License,
version 2, as published by the Free Software Foundation.  ----- */

/* This file is derived from code in the Linux C Library, hence the following: */

/* Copyright (C) 1993  Olaf Flebbe
This file is part of the Linux C Library.

The Linux C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The Linux C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.  */

#define _FPU_RESERVED 0xF0C0  /* Reserved bits in cw */

void
invl_setfpucw(unsigned short fpu_control)
{
	volatile unsigned short cw;

	asm volatile ("fclex" );

	/* Get Control Word */
	asm volatile ("fnstcw %0" : "=m" (cw) : );
  
	/* mask in */
	cw &= _FPU_RESERVED;
	cw = cw | (fpu_control & ~_FPU_RESERVED);

	/* set cw */
	asm volatile ("fldcw %0" :: "m" (cw));
}
