#include "invariant/restricted_types.h"
#include "invariant/assert.h"
#include <iostream.h>
#include <functional>
#include "test.h"
#include <pfstream.h>

//	this file tests out restricted_types.h

int
main()
{
	PR_EX( set_assert_mode(assert_msg))

	typedef monotone<double, greater<double> > mdg;

	PR_EX( mdg x(5) )
	PR_EX( mdg y(6) )
	PR_EX( mdg z(4) )

	PR_EX( cout << x << " " << x*x << endl )
	PR_EX( x = 3.0 )
	PR_EX( x = 4.0 )
	PR_EX( cout << x << " " << x*x << endl )
	PR_EX( x = y )
	PR_EX( x = z )
	PR_EX( cout << x << " " << x*x << endl )
	PR_EX( cout << "   " << -x << endl )

	double	d;
	int	k;
	float	f;
	PR_EX( d = 2.0+x )
	PR_EX( k = 2.0+x )
	PR_EX( f = 2.0+x )
	PR_EX( z = 3.0+x )
//	PR_EX( z *= 3.0 ) 	doesn't compile

	typedef definite<double, greater_equal<double> > ddg;
	PR_EX( ddg a(0) )
	PR_EX( ddg b(1) )
	PR_EX( a = 2.0)
	PR_EX( a = b )
	PR_EX( a = -1.0 )
	PR_EX( cout << a << " " << a*a << endl )
	PR_EX( cout << "   " << -a << endl )

	cout << endl << "testing unchanged class" << endl;

	double db(5.0);
	{
		cout << "beginning scope" << endl;
		PR_EX( unchanged<double> ud(db) )
		cout << "end of scope" << endl;
	}

	{
		cout << "beginning scope" << endl;
		PR_EX( unchanged<double> ud(db) )
		PR_EX( db += 1.0 )
		cout << "end of scope" << endl;
	}
	cout << endl;

	ddg  d2(5.0);
	{
		cout << "beginning scope" << endl;
		PR_EX( unchanged<ddg> ud(d2) )
		UNCHANGED(d2);
		cout << "checking unchange...\n";
		CHECK_UNCHANGED(d2);
		cout << "end of scope" << endl;
	}
	{
		cout << "beginning scope" << endl;
		PR_EX( unchanged<ddg> ud(d2) )
		UNCHANGED(d2);
		PR_EX( d2 = d2+1.0 )
		cout << "checking unchange...\n";
		CHECK_UNCHANGED(d2);
		cout << "end of scope" << endl;
	}

	typedef Interval_num<double, 0, 2> idn;
	PR_EX( idn p(0) )
	PR_EX( idn q(1) )
	PR_EX( p = 2.0)
	PR_EX( p =   q  )
	PR_EX( p = -1.0 )
	PR_EXD( p =  3.0 )
	PR_EXD( p =  q+1 )
	PR_EXD( p =  q*q )
	PR_EX( cout << p << " " << p*p << endl )
	PR_EX( cout << "   " << -p << endl )

	cout << endl << "now testing out the smart_num.h part\n";
	bool bl;
	PR_EXB( bl = ( p==q) )
	PR_EXB( bl = ( p!=q) )
	PR_EXB( bl = ( p>=q) )
	PR_EXB( bl = ( p>q) )
	PR_EXB( bl = ( p<q) )
	PR_EX( p++ )	cout << ": " << p << endl;
	PR_EX( p += -0.2 )	cout << ": " << p << endl;
	PR_EX( p *=  0.5 )	cout << ": " << p << endl;
	PR_EX( p /=  2.0 )	cout << ": " << p << endl;


	cout << "testing definite<...> numbers" << endl;
	{
		ddg r(1), s(1);	
		PR_EXB( bl = ( r==s) )
		PR_EXB( bl = ( r!=s) )
		PR_EXB( bl = ( r>=s) )
		PR_EXB( bl = ( r>s) )
		PR_EXB( bl = ( r<s) )
		PR_EX( r++ )	cout << ": " << r << endl;
		PR_EX( r += -0.2 )	cout << ": " << r << endl;
		PR_EX( r *=  0.5 )	cout << ": " << r << endl;
		PR_EX( r /=  2.0 )	cout << ": " << r << endl;
	}

	cout << "testing monotone<...> numbers" << endl;
	{
		mdg r(1), s(1);	
		PR_EXB( bl = ( r==s) )
		PR_EXB( bl = ( r!=s) )
		PR_EXB( bl = ( r>=s) )
		PR_EXB( bl = ( r>s) )
		PR_EXB( bl = ( r<s) )
		PR_EX( r++ )	cout << ": " << r << endl;
		PR_EX( r += -0.2 )	cout << ": " << r << endl;
		PR_EX( r *=  0.5 )	cout << ": " << r << endl;
		PR_EX( r /=  2.0 )	cout << ": " << r << endl;
	}


	cout << "all done!" << endl;
}

	
