#include "invariant/nonnull_ptr.h"
#include "invariant/assert.h"
#include <iostream.h>
#include "vec2.h"
#include "test.h"

//	this file tests out nonnull_ptr.h

int
main()
{
	PR_EX( set_assert_mode(assert_msg))
	PR_EX( vec2 v(1,2) )
	PR_EX( vec2 w(2,3) )

	cout << "testing out restricted_ptr\n";
	PR_EX( restricted_ptr<vec2> pvr( &v) )
	PR_EX( restricted_ptr<vec2> pwr( &w) )
	PR_EX( double dr = pvr->x )
	PR_EX( cout << "   " << dr << endl )
	PR_EX( vec2 xr = *pvr )
	PR_EX( cout << "  " << xr.x << "  " << xr.y << endl )
	PR_EX( pvr  = (vec2 *)0  )
	cout << endl;

#ifdef BAD_1
	cout << "testing array capabilitiesof restricted_ptr\n";
	PR_EX( pwr = pvr+1 )
	PR_EX( pwr = 1+pvr )
	PR_EX( vec2 v2 = pvr[0] )
	PR_EX( cout << hex << (vec2 *) pvr << endl )
	PR_EX( vec2 v3 = pvr[1] )
	PR_EX( int ir = pvr - pwr )
	PR_EX( int i2r = pvr - &v2 )
#endif // BAD_1

#ifdef BAD_3
	PR_EX( int  i3r = &v - pvr )
#endif // BAD_3

	cout << "testing out nonnull_ptr\n";
	PR_EX( nonnull_ptr<vec2> pv0( &v) )
	PR_EX( nonnull_ptr<vec2> pw0( &w) )
	PR_EX( double d0 = pv0->x )
	PR_EX( cout << "   " << d0 << endl )
	PR_EX( vec2 x0 = *pv0 )
	PR_EX( cout << "  " << x0.x << "  " << x0.y << endl )
	PR_EX( pv0  = (vec2 *)0  )
	cout << endl;

#ifdef BAD_2
	cout << "testing array capabilitiesof restricted_ptr\n";
	PR_EX( pw0 = pv0+1 )
	PR_EX( pw0 = 1+pv0 )
	PR_EX( vec2 v22 = pv0[0] )
	PR_EX( cout << hex << (vec2 *) pv0 << endl )
	PR_EX( vec2 v33 = pv0[1] )
	PR_EX( int i0 = pv0 - pw0 )
	PR_EX( int i20 = pv0 - &v22 )
	PR_EX( int i30 = &v22 - pv0 )
#endif BAD_2

	cout << "testing out nonnull_arr_ptr\n";
	PR_EX( nonnull_arr_ptr<vec2> pv( &v) )
	PR_EX( nonnull_arr_ptr<vec2> pw( &w) )
	PR_EX( double d = pv->x )
	PR_EX( cout << "   " << d << endl )
	PR_EX( vec2 x = *pv )
	PR_EX( cout << "  " << x.x << "  " << x.y << endl )
	PR_EX( pv  = (vec2 *)0  )
	cout << endl;

	cout << "testing out the array pointer methods of nonnull_arr_ptr\n";
	PR_EX( cout << pv - pw << endl )
	PR_EX( pv = pv + 3 )
	PR_EX( pv = pv - 1 )
	PR_EX( pv += 3 )
	PR_EX( pv++ )
	PR_EX( pv-- )
	PR_EX( --pv )
	PR_EX( ++pv )
	PR_EX( nonnull_arr_ptr<vec2> px( (vec2 *)0 )  )
	PR_EX( cout << hex << (void *)px << endl )
	PR_EX( ++px )
	PR_EX( cout << hex << (void *)px << endl )
	PR_EX( --px )
	PR_EX( cout << hex << (void *)px << endl )
	PR_EX( px++ )
	PR_EX( px.check() )
	PR_EX( cout << hex << (void *)px << endl )
	PR_EX( px-- )
	PR_EX( cout << hex << (void *)px << endl )
	PR_EX( px = &v )
	PR_EX( cout << px[0].x << " " << px[0].y <<  endl )
	
	cout << "all done!" << endl;
}

