#include "invariant/unit_numbers.h"
#include "invariant/assert.h"
#include <iostream.h>
#include <stdlib.h>
#include "test.h"

//	this file tests out unit_numbers.h

int
main()
{
	PR_EX( set_assert_mode(assert_msg) )

	unit_number<double, LENGTH> width(2.0);
	unit_number<double, LENGTH> height(4.0);
	unit_number<double, LENGTH> h2;
	unit_number<double, DIMENSIONLESS> aspect_ratio, a2;

	aspect_ratio = height/width;
	cout << "aspect ratio = " << aspect_ratio <<endl;
	PR_EX( h2 = aspect_ratio*width )
	cout << "h2= " << h2 << endl;
	PR_EX( a2 = exp(aspect_ratio) )
	cout << "a2 = " << a2 << endl;
	PR_EX( a2 = sin(aspect_ratio) )
	cout << "a2 = " << a2 << endl;
	PR_EX( a2 = j0(aspect_ratio) )
	cout << "a2 = " << a2 << endl;
	PR_EX( a2 = asinh(aspect_ratio) )
	cout << "a2 = " << a2 << endl;

#ifdef  BAD_1
	a2 = aspect_ratio*width;	// cannot assign distance to area.
#elif	BAD_2
	a2 = aspect_ratio + width;	// cannot add length to dimensionless
#endif

	PR_EX( h2 = width + height )
	cout << "h2= " << h2 << endl;

	unit_number<double, DIMENSIONLESS> pi(3.14159265358979);
//	unit_number<double, LENGTH> r=2.0;	doesn't work: copy constructor.
	unit_number<double, LENGTH> r(2.0);
	unit_number<double, AREA> a = pi*r*r;
	cout << "area = " << a << endl;

#ifdef  BAD_3
	unit_number<double, VOLUME> v = pi*r*r; // cannot assign area to volume.
	cout << "volume= " << v << endl;
#endif

#ifdef  BAD_4
//	because return type is ignored in binary-op conversion determination,
//	2.0*r and r*2.0 are ambiguous; can convert 2.0 to anything and multiply
//	it by r.  Addition should work, though. (now fixed)

	unit_number<double,AREA> v = pi*r*2.0; 
	unit_number<double,AREA> v2= 2.0*pi*r;
	cout << "volume= " << v << endl;
#endif

#ifdef  BAD_5
	unit_number<double,LENGTH> v3 = r+2.0; // This no longer works.
	cout << "v3(=r+2) = " << v3 << endl;
#endif

//	double dz = ((double) h2); // Sigh, doesn't work.
//	double dw = double(h2);	// Doesn't work either
	double dx = ( (number_proxy<double>) h2); 
	cout << "dx= " << dx << endl;
//	double dy = sqrt( h2);	doesn't work

	cout << "h2= " << h2 << endl;
	h2 += h2;
	cout << "h2= " << h2 << endl;
	h2 = -h2;
	cout << "h2= " << h2 << endl;
	h2 *= aspect_ratio;
	cout << "h2= " << h2 << endl;
	h2 /= aspect_ratio;
	cout << "h2= " << h2 << endl;
	h2 -= h2;
	cout << "h2= " << h2 << endl;

	cout << " \n testing comparisions\n";
	unit_number<double, LENGTH> h = height;
	cout << "h=" << h << " h2=" << h2 << endl;

	cout <<  "h<h2: " << (h<h2) << endl;
	cout <<  "h<=h2: " << (h<=h2) << endl;
	cout <<  "h>=h2: " << (h>=h2) << endl;
	cout <<  "h>h2: " << (h>h2) << endl;
	cout <<  "h==h2: " << (h==h2) << endl;
	
	cout << "all done!" << endl;
}

