#include <iostream.h>
#include "test.h"
#include "invariant/unit_numbers.h"
#include "invariant/nonnull_ptr.h"
// #include "invariant/assert.h"
#include "vec2.h"

// this file tests the correctness of self-assignment
// for smart pointers and smart numbers.

template <class N> 
void
test_self_assign( N n)
{
	cout << "  prior:" << n;
	n = n;
	cout << "  posterior:" << n;
	cout << endl;
}

template <class P> 
void
test_self_assign_ptr( P p)
{
	cout << "  prior:" << (void *)p;
	p = p;
	cout << "  posterior:" << (void *)p;
	cout << endl;
}

int
main()
{
	cout << "self-assignment for unit_numbers" << endl;

	unit_number<double, LENGTH> r(2.0);
	PR_EX( test_self_assign(r) )
	unit_number<double, DIMENSIONLESS> r2(2.0);
	PR_EX( test_self_assign(r2) )

	cout << "\n self-assignment for nunnull_ptrs" << endl;
	int i=79;
	nonnull_ptr<int>  npi(&i);
	int j = *npi;
	PR_EX( test_self_assign_ptr(npi) )
	
	PR_EX( vec2 v(1,2) )
	nonnull_ptr<vec2> pv(&v);
//	nonnull_ptr<vec2> pw;
	vec2 w = *pv;
	PR_EX( vec2 z = *pv )
	
}

